import java.util.*;
import java.io.*;
import java.awt.*;
import javax.swing.*;

public class Visualize extends Canvas {

  Vector counts;
  int    linePos, range;

  public Visualize() {
    counts = new Vector();
    linePos = 0;
    range = 1000;
  }

  public static void main( String[] args ) {
    JFrame top = new JFrame();
    Visualize thisVis = new Visualize();
    top.setSize(500,300);
    top.getContentPane().add( thisVis );
    top.show();

    Graphics g = thisVis.getGraphics();

    while( true ) {
      BufferedReader sin = 
	new BufferedReader( new InputStreamReader(System.in) );  
      try {
	String newLine = sin.readLine();
	StringTokenizer reader = new StringTokenizer(newLine);
	String head = reader.nextToken();
	if( head.equalsIgnoreCase("value") ) {
	  Integer newValue = new Integer( reader.nextToken() );
	  System.out.println( "received value " + newValue );
	  thisVis.drawLine( g, newValue.intValue() );
	  thisVis.counts.add( newValue );
	} else 
	  System.out.println( newLine );
      } catch( IOException e ) { }
    }
//      thisVis.drawLine( g, 100 );
//      thisVis.counts.add( new Integer(100) );
//      thisVis.drawLine( g, 200 );
//      thisVis.counts.add( new Integer(200) );
  }

  public void paint( Graphics g ) { 
    g.setColor( getBackground() );
    g.fillRect( 0, 0, getWidth(), getHeight() );
    linePos = 0;
    g.setColor( Color.black );
    for( Enumeration c = counts.elements(); c.hasMoreElements(); ) {
      int l =  ((Integer)c.nextElement()).intValue();
      drawLine( g, l );
    }
  }

  public void drawLine( Graphics g, int count ) {
    int interval = getWidth()/25;
    int x = linePos*interval + interval/2;
    g.drawLine( x, getHeight(), x, getHeight()-count*getHeight()/range );
    linePos++;
  }  

}
